diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 579acb765..51ae70bf7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -61,7 +61,6 @@ import org.slf4j.Logger;
 
 public class HudIngame extends Gui {
     public static final float DEBUG_SCALE = 1f;
-    public static final int MAX_CHAT_WIDTH = 320;
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final Direction[] directions = new Direction[]{Direction.NORTH, Direction.EAST, Direction.SOUTH, Direction.WEST};
 
@@ -70,7 +69,6 @@ public class HudIngame extends Gui {
     private static final float ACID_OVERLAY_LERP_UP = 0.13F;
     private static final float ACID_OVERLAY_LERP_DOWN = 0.038F;
 
-    private final @NotNull List<@NotNull ChatLine> chatMessageList = new ArrayList<>();
     protected Minecraft mc;
     public int updateCounter = 0;
     private String recordPlaying = "";
@@ -81,7 +79,6 @@ public class HudIngame extends Gui {
     protected float acidOverlayAlpha;
     protected float acidImmersionRamp;
     protected FontRenderer fontRenderer;
-    public int chatScroll = 0;
 
 
     public HudIngame(Minecraft minecraft) {
@@ -122,7 +119,7 @@ public class HudIngame extends Gui {
         for (final HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component.isVisible()) {
                 GLRenderer.pushFrame();
-                component.render(this, width, height, partialTicks);
+                component.renderScaled(this, width, height, partialTicks);
                 GLRenderer.popFrame();
             }
         }
@@ -395,10 +392,6 @@ public class HudIngame extends Gui {
             }
         }
 
-        if (GameSettings.IMMERSIVE_MODE.drawChat()) {
-            drawChat(width, height);
-        }
-
         // Adding this mostly to see if the stitcher and dynamic textures are working properly
         if (GameSettings.KEY_TOGGLE_TEXTURE_ATLAS.isPressed()) {
             GLRenderer.pushFrame();
@@ -563,63 +556,6 @@ public class HudIngame extends Gui {
         }
     }
 
-    public void drawChat(int width, int height) {
-        if (GameSettings.chatVisibility.value == ChatVisibility.NEVER_SHOW) return;
-//        if(mc.currentScreen instanceof ScreenChat && ((ScreenChat) mc.currentScreen).message.startsWith("/")) return;
-        int linesToShow = 10;
-        boolean ignoreFadeout = false;
-        if (this.mc.currentScreen instanceof ScreenChat) {
-            int acceptableSize = height - 48 - 48;
-            linesToShow = acceptableSize / 9;
-            ignoreFadeout = true;
-        } else if (GameSettings.chatVisibility.value == ChatVisibility.SHOW_WHEN_CHATTING) {
-            return;
-        }
-
-        if (this.chatScroll > this.chatMessageList.size() - linesToShow)
-            this.chatScroll = this.chatMessageList.size() - linesToShow;
-        if (this.chatScroll < 0) this.chatScroll = 0;
-
-        GLRenderer.enableState(State.BLEND);
-        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        GLRenderer.pushFrame();
-        GLRenderer.modelM4f().translate(0.0F, height - 48, 0.0F);
-        int y = -12;
-        for (int i = 0; i < linesToShow; i++) {
-            if (this.chatScroll + i >= this.chatMessageList.size()) continue;
-            final ChatLine line = this.chatMessageList.get(this.chatScroll + i);
-            if (line.updateCounter >= 190 && !ignoreFadeout) {
-                continue;
-            }
-            double fadeAmount = (double) line.updateCounter / 200D;
-            fadeAmount = 1.0D - fadeAmount;
-            fadeAmount *= 10D;
-            if (fadeAmount < 0.0D) {
-                fadeAmount = 0.0D;
-            }
-            if (fadeAmount > 1.0D) {
-                fadeAmount = 1.0D;
-            }
-            fadeAmount *= fadeAmount;
-            int alpha = (int) (255D * fadeAmount);
-            if (ignoreFadeout) {
-                alpha = 255;
-            }
-            if (alpha > 0) {
-                final CharSequence message = line.message;
-                final byte xPad = 2;
-                final int h = MathHelper.ceil(this.fontRenderer.heightOfConstrainedChars(message, MAX_CHAT_WIDTH));
-                y -= (h + 2);
-                drawRect(xPad, y - 1, xPad + MAX_CHAT_WIDTH, y + h + 1, alpha / 2 << 24);
-                GLRenderer.enableState(State.BLEND);
-                this.fontRenderer.renderWidthConstrained(message, xPad, y, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
-            }
-        }
-
-        GLRenderer.popFrame();
-        GLRenderer.disableState(State.BLEND);
-    }
-
     public static String getTimeString(Minecraft mc) {
         long worldTime = mc.currentWorld.getWorldTime();
         int dayLength = Global.DAY_LENGTH_TICKS;
@@ -772,22 +708,16 @@ public class HudIngame extends Gui {
             this.recordPlayingUpFor--;
         }
         this.updateCounter++;
-        for (ChatLine chatLine : this.chatMessageList) {
-            chatLine.updateCounter++;
-        }
-
+        HudComponents.CHAT.updateTick();
     }
 
     public void clearChatMessages() {
-        this.chatMessageList.clear();
+        HudComponents.CHAT.clearChatMessages();
     }
 
     public void addChatMessage(final CharSequence s) {
         LOGGER.info("[CHAT] {}", s);
-        this.chatMessageList.add(0, new ChatLine(s));
-        while (this.chatMessageList.size() > 100) {
-            this.chatMessageList.remove(this.chatMessageList.size() - 1);
-        }
+        HudComponents.CHAT.addChatMessage(s);
     }
 
     public void setRecordPlayingMessage(String s) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
index b21e0784a..6b089a1da 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
@@ -1,18 +1,24 @@
 package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.ScaledResolution;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.ScreenHudEditor;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.gui.options.components.BooleanToggleComponent;
 import net.minecraft.client.gui.options.components.KeyBindingComponent;
 import net.minecraft.client.gui.options.components.OptionsComponent;
+import net.minecraft.client.gui.options.components.ToggleableOptionComponent;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.Option;
+import net.minecraft.client.option.OptionGuiScaleOverride;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -33,11 +39,71 @@ public abstract class HudComponent {
 
     Layout layout;
 
+    private boolean snapToFill = true;
+    private static final boolean DEFAULT_SNAP_TO_FILL = true;
+    private OptionGuiScaleOverride guiScaleOverride = new OptionGuiScaleOverride();
+
     public HudComponent(String key, int xSize, int ySize, Layout layout) {
         this.key = key;
         this.xSize = xSize;
         this.ySize = ySize;
         this.layout = layout;
+
+        addDefaultOptionSuppliers();
+    }
+
+    protected void addDefaultOptionSuppliers() {
+        this.optionComponentSuppliers.add(() -> new BooleanToggleComponent(
+            "gui.options.hudeditor.snap_to_fill",
+            DEFAULT_SNAP_TO_FILL,
+            this::isSnapToFill,
+            this::setSnapToFill
+        ));
+
+        this.optionComponentSuppliers.add(() -> new ToggleableOptionComponent<>(
+            this.getGuiScaleOverrideOption()
+        ).applyOnRelease());
+    }
+
+    public boolean isSnapToFill() {
+        return this.snapToFill;
+    }
+
+    public void setSnapToFill(boolean snapToFill) {
+        this.snapToFill = snapToFill;
+    }
+
+    public OptionGuiScaleOverride getGuiScaleOverrideOption() {
+        return this.guiScaleOverride;
+    }
+
+    protected void setGuiScaleOverrideOption(OptionGuiScaleOverride override) {
+        this.guiScaleOverride = override;
+    }
+
+    public int getScaleOverride() {
+        return this.getGuiScaleOverrideOption().value;
+    }
+
+    public void setScaleOverride(int value) {
+        this.getGuiScaleOverrideOption().value = Math.max(0, value);
+    }
+
+    public static int getEffectiveGlobalScale() {
+        int v = GameSettings.GUI_SCALE.value;
+        if (v > 0) return v;
+        return ScaledResolution.getMaxScale(
+            mc.gameWindow.getWidthScreenCoords(),
+            mc.gameWindow.getHeightScreenCoords()
+        );
+    }
+
+    public float getScale() {
+        int override = getScaleOverride();
+        if (override <= 0) return 1.0f;
+        int global = getEffectiveGlobalScale();
+        if (global <= 0) return 1.0f;
+        return (float) override / (float) global;
     }
 
     public abstract boolean isVisible();
@@ -61,37 +127,51 @@ public abstract class HudComponent {
         return key;
     }
 
+    /**
+     * Returns the base (unscaled) horizontal size of the component.
+     */
+    public int getBaseXSize() {
+        return xSize;
+    }
+
+    /**
+     * Returns the base (unscaled) vertical size of the component.
+     */
+    public int getBaseYSize() {
+        return ySize;
+    }
+
     public int getDisplayedXSize() {
         if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudEditor) && !isVisible())) return 0;
-        return xSize;
+        return Math.round(getBaseXSize() * getScale());
     }
 
     public int getDisplayedYSize() {
         if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudEditor) && !isVisible())) return 0;
-        return ySize;
+        return Math.round(getBaseYSize() * getScale());
     }
 
-    public int getDisplayedAnchorX(ComponentAnchor anchor) {
+    public int getDisplayedAnchorX(@NotNull ComponentAnchor anchor) {
         return (int) (anchor.xPosition * this.getDisplayedXSize());
     }
 
-    public int getDisplayedAnchorY(ComponentAnchor anchor) {
+    public int getDisplayedAnchorY(@NotNull ComponentAnchor anchor) {
         return (int) (anchor.yPosition * this.getDisplayedYSize());
     }
 
     public int getTrueXSize() {
-        return xSize;
+        return Math.round(getBaseXSize() * getScale());
     }
 
     public int getTrueYSize() {
-        return ySize;
+        return Math.round(getBaseYSize() * getScale());
     }
 
-    public int getTrueAnchorX(ComponentAnchor anchor) {
+    public int getTrueAnchorX(@NotNull ComponentAnchor anchor) {
         return (int) (anchor.xPosition * this.getTrueXSize());
     }
 
-    public int getTrueAnchorY(ComponentAnchor anchor) {
+    public int getTrueAnchorY(@NotNull ComponentAnchor anchor) {
         return (int) (anchor.yPosition * this.getTrueYSize());
     }
 
@@ -117,6 +197,10 @@ public abstract class HudComponent {
         return this.optionComponentSuppliers;
     }
 
+    protected void addOptionComponentSupplier(Supplier<OptionsComponent> supplier) {
+        this.optionComponentSuppliers.add(supplier);
+    }
+
     public List<Supplier<KeyBindingComponent>> getKeyBindingSuppliers() {
         return this.keyBindingComponentSuppliers;
     }
@@ -133,7 +217,41 @@ public abstract class HudComponent {
 
     public abstract void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen);
 
-    public final String toSettingsString() {
+    /**
+     * Renders the component, applying the per-component scale via a GL transform.
+     */
+    public final void renderScaled(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        float scale = getScale();
+        if (scale == 1.0f) {
+            render(hud, xSizeScreen, ySizeScreen, partialTick);
+            return;
+        }
+        int x = this.layout.getComponentX(this, xSizeScreen);
+        int y = this.layout.getComponentY(this, ySizeScreen);
+        GLRenderer.modelM4f().translate(x, y, 0.0f);
+        GLRenderer.modelM4f().scale(scale, scale, 1.0f);
+        GLRenderer.modelM4f().translate(-x, -y, 0.0f);
+        render(hud, xSizeScreen, ySizeScreen, partialTick);
+    }
+
+    /**
+     * Renders the preview, applying the per-component scale via a GL transform.
+     */
+    public final void renderPreviewScaled(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        float scale = getScale();
+        if (scale == 1.0f) {
+            renderPreview(gui, layout, xSizeScreen, ySizeScreen);
+            return;
+        }
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
+        GLRenderer.modelM4f().translate(x, y, 0.0f);
+        GLRenderer.modelM4f().scale(scale, scale, 1.0f);
+        GLRenderer.modelM4f().translate(-x, -y, 0.0f);
+        renderPreview(gui, layout, xSizeScreen, ySizeScreen);
+    }
+
+    public final @NotNull String toSettingsString() {
         String layoutString;
         if (layout instanceof LayoutAbsolute) {
             layoutString = "abs";
@@ -142,10 +260,13 @@ public abstract class HudComponent {
         } else {
             throw new RuntimeException("Unknown layout type: " + layout.getClass().getName());
         }
-        return key + "{[" + toSettingsParametersString() + "];" + layoutString + "[" + layout.toSettingsString() + "]}";
+        return key + "{[" + toSettingsParametersString() + "];"
+            + layoutString + "[" + layout.toSettingsString() + "];"
+            + "fill[" + this.snapToFill + "];"
+            + "override[" + this.getScaleOverride() + "]}";
     }
 
-    public final void fromSettingsString(String settings) {
+    public final void fromSettingsString(@NotNull String settings) {
         String[] parts = settings.split(";");
         String parameters = parts[0].substring(1, parts[0].length() - 1);
         fromSettingsParametersString(parameters);
@@ -159,6 +280,25 @@ public abstract class HudComponent {
             throw new RuntimeException("Unknown layout type: " + layoutString);
         }
         layout.fromSettingsString(layoutSettings);
+
+        this.snapToFill = DEFAULT_SNAP_TO_FILL;
+        this.setScaleOverride(0);
+        for (int i = 2; i < parts.length; i++) {
+            String part = parts[i];
+            int bracketStart = part.indexOf('[');
+            if (bracketStart < 0) continue;
+            String name = part.substring(0, bracketStart);
+            String value = part.substring(bracketStart + 1, part.endsWith("}") ? part.length() - 2 : part.length() - 1);
+            if (name.equals("fill")) {
+                this.snapToFill = Boolean.parseBoolean(value);
+            } else if (name.equals("override")) {
+                try {
+                    this.setScaleOverride(Integer.parseInt(value));
+                } catch (NumberFormatException ignored) {
+                    this.setScaleOverride(0);
+                }
+            }
+        }
     }
 
     protected String toSettingsParametersString() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java
new file mode 100644
index 000000000..665fac4a2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java
@@ -0,0 +1,283 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.options.components.FloatSliderComponent;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.core.enums.ChatVisibility;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.core.net.ChatLine;
+import net.minecraft.client.gui.chat.ScreenChat;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+
+public class HudComponentChat extends HudComponentMovable {
+    public static final int DEFAULT_CHAT_WIDTH = 220;
+    public static final int DEFAULT_CHAT_HEIGHT = 110;
+    public static final int MIN_CHAT_WIDTH = 80;
+    public static final int MAX_RESIZE_WIDTH = 600;
+    public static final int MIN_CHAT_HEIGHT = 30;
+    public static final int MAX_RESIZE_HEIGHT = 1000;
+    private static final int CHAT_PADDING = 2;
+    private static final int LINE_SPACING = 2;
+    public final @NotNull List<@NotNull ChatLine> chatMessageList = new ArrayList<>();
+    public int chatScroll = 0;
+
+    private int customWidth;
+    private int customHeight;
+
+    public HudComponentChat(String key, int xSize, int ySize, Layout layout) {
+        super(key, xSize, ySize, layout);
+        this.customWidth = xSize;
+        this.customHeight = ySize;
+
+        setSnapToFill(false);
+
+        addOptionComponentSupplier(() -> new FloatSliderComponent(
+            "gui.options.hudeditor.chat_width",
+            DEFAULT_CHAT_WIDTH,
+            MIN_CHAT_WIDTH,
+            MAX_RESIZE_WIDTH,
+            () -> (float) this.customWidth,
+            value -> this.customWidth = Math.round(value),
+            value -> Math.round(value) + "px"
+        ));
+
+        addOptionComponentSupplier(() -> new FloatSliderComponent(
+            "gui.options.hudeditor.chat_height",
+            DEFAULT_CHAT_HEIGHT,
+            MIN_CHAT_HEIGHT,
+            MAX_RESIZE_HEIGHT,
+            () -> (float) this.customHeight,
+            value -> this.customHeight = Math.round(value),
+            value -> Math.round(value) + "px"
+        ));
+    }
+
+    @Override
+    public int getBaseXSize() {
+        return this.customWidth;
+    }
+
+    @Override
+    public int getBaseYSize() {
+        return this.customHeight;
+    }
+
+    @Override
+    protected String toSettingsParametersString() {
+        return "w=" + this.customWidth + ",h=" + this.customHeight;
+    }
+
+    @Override
+    protected void fromSettingsParametersString(String settings) {
+        if (settings == null || settings.isEmpty()) return;
+        for (String token : settings.split(",")) {
+            int eq = token.indexOf('=');
+            if (eq < 0) continue;
+            String key = token.substring(0, eq);
+            String value = token.substring(eq + 1);
+            try {
+                int parsed = Integer.parseInt(value);
+                if (key.equals("w")) {
+                    this.customWidth = MathHelper.clamp(parsed, MIN_CHAT_WIDTH, MAX_RESIZE_WIDTH);
+                } else if (key.equals("h")) {
+                    this.customHeight = MathHelper.clamp(parsed, MIN_CHAT_HEIGHT, MAX_RESIZE_HEIGHT);
+                }
+            } catch (NumberFormatException ignored) {}
+        }
+    }
+
+    @Override
+    public boolean isVisible() {
+        if (GameSettings.chatVisibility.value == ChatVisibility.NEVER_SHOW) return false;
+        if (!GameSettings.IMMERSIVE_MODE.drawChat()) return false;
+        return GameSettings.chatVisibility.value != ChatVisibility.SHOW_WHEN_CHATTING || mc.currentScreen instanceof ScreenChat;
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        drawChat(hud, xSizeScreen, ySizeScreen);
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return !isVisible();
+    }
+
+    @Override
+    public void renderPreview(Gui gui, @NotNull Layout layout, int xSizeScreen, int ySizeScreen) {
+
+        renderTranslucency();
+
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
+
+        List<String> previews = Arrays.asList(
+            "<Scratchylongnose> Hello, and welcome!",
+            "<EthosRoom> Look at all those chickens..",
+            "<ModernBeef> Who knows where the basalt farm is?",
+            "<JumboHumbo> A little overengineered I guess..",
+            "<CaptainSunshine> Creeper! Aww man..",
+            "<DriftySpawners> Starting a fresh build at spawn tonight.",
+            "<MildFruitDrink> So uhh.. when are melons getting added?",
+            "<MasterCaver> I catalogued every ore vein in this cave.",
+            "<NoSenseOfDirection> Uhh, I'm a bit lost... this server have TPA?",
+            "<CreeperCrazy> they always move left... I SWEAR THEY DO BELIEVE ME!",
+            "<TorchRunner> Lighting up this whole mountain by hand.",
+            "<ClayFarmer> Sorry this river is out of clay.",
+            "<RailSmith> New nether hub is opening soon",
+            "<RedstoneRambler> Hey come take a look at this 0t cobble farm!",
+            "<MapMaker> [Doesn't exist]",
+            "<DiamondDaisy> Like actually, genuine 16 MEGA VEIN the other day",
+            "<PistonPoet> Look all I'm saying is doors should feel dramatic when they open.",
+            "<BuilderBea> Need opinions on this roof gradient.",
+            "<FarlandsFan> Almost there...",
+            "<WoolWizard> Sheep colors are sorted, labeled, and currently farming.",
+            "<OceanOtto> Yeah I'm never draining any ocean again, get me out of here.",
+            "<Herobrine> Really, a herobrine reference in BTA? Ugh."
+        );
+        drawLines(gui, mc.font, previews, x, y, 255);
+    }
+
+    public void updateTick() {
+        for (ChatLine chatLine : this.chatMessageList) {
+            chatLine.updateCounter++;
+        }
+    }
+
+    public void clearChatMessages() {
+        this.chatMessageList.clear();
+    }
+
+    public void addChatMessage(final CharSequence s) {
+        this.chatMessageList.add(0, new ChatLine(s));
+        while (this.chatMessageList.size() > 100) {
+            this.chatMessageList.remove(this.chatMessageList.size() - 1);
+        }
+    }
+
+    private int getMessageWrapWidth() {
+        return Math.max(1, this.customWidth - (CHAT_PADDING * 2));
+    }
+
+    private void drawChat(HudIngame hud, int xSizeScreen, int ySizeScreen) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        int wrapWidth = getMessageWrapWidth();
+        int singleLineHeight = 9 + LINE_SPACING;
+        int linesToShow = Math.max(1, (this.customHeight - CHAT_PADDING * 2) / singleLineHeight);
+        boolean ignoreFadeout = false;
+        if (mc.currentScreen instanceof ScreenChat) {
+            int acceptableSize = ySizeScreen - 48 - 48;
+            linesToShow = Math.max(linesToShow, acceptableSize / singleLineHeight);
+            ignoreFadeout = true;
+        }
+
+        if (this.chatScroll > this.chatMessageList.size() - linesToShow)
+            this.chatScroll = this.chatMessageList.size() - linesToShow;
+        if (this.chatScroll < 0) this.chatScroll = 0;
+
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        int linesUsed = Math.min(linesToShow, this.chatMessageList.size() - this.chatScroll);
+        int totalHeight = computeTotalHeight(this.chatMessageList, this.chatScroll, linesUsed, ignoreFadeout, wrapWidth);
+
+        float yMult = GameSettings.VERTICAL_CHAT_TEXT_ALIGNMENT.value.multiplier;
+        int alignmentSpace = this.getBaseYSize() - (CHAT_PADDING * 2) - totalHeight;
+
+        int currentY = y + this.getBaseYSize() - CHAT_PADDING - (int) (alignmentSpace * (1 - yMult));
+        for (int i = 0; i < linesToShow; i++) {
+            if (this.chatScroll + i >= this.chatMessageList.size()) continue;
+            final ChatLine line = this.chatMessageList.get(this.chatScroll + i);
+            if (line.updateCounter >= 190 && !ignoreFadeout) {
+                continue;
+            }
+            double fadeAmount = (double) line.updateCounter / 200D;
+            fadeAmount = 1.0D - fadeAmount;
+            fadeAmount *= 10D;
+            if (fadeAmount < 0.0D) {
+                fadeAmount = 0.0D;
+            }
+            if (fadeAmount > 1.0D) {
+                fadeAmount = 1.0D;
+            }
+            fadeAmount *= fadeAmount;
+            int alpha = (int) (255D * fadeAmount);
+            if (ignoreFadeout) {
+                alpha = 255;
+            }
+            if (alpha > 0) {
+                final CharSequence message = line.message;
+                final int h = MathHelper.ceil(mc.font.heightOfConstrainedChars(message, wrapWidth));
+                currentY -= (h + LINE_SPACING);
+                drawAlignedLine(hud, mc.font, message, x, currentY, h, alpha, wrapWidth);
+            }
+        }
+        GLRenderer.disableState(State.BLEND);
+    }
+
+    private void drawLines(Gui gui, FontRenderer sr, @NotNull List<String> messages, int x, int y, int alpha) {
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+
+        int wrapWidth = getMessageWrapWidth();
+        int maxContentHeight = Math.max(1, this.getBaseYSize() - (CHAT_PADDING * 2));
+        List<String> visibleMessages = new ArrayList<>();
+        int totalHeight = 0;
+        for (String message : messages) {
+            int lineHeight = MathHelper.ceil(sr.heightOfConstrainedChars(message, wrapWidth)) + LINE_SPACING;
+            if (totalHeight + lineHeight > maxContentHeight) {
+                break;
+            }
+            visibleMessages.add(message);
+            totalHeight += lineHeight;
+        }
+
+        float yMult = GameSettings.VERTICAL_CHAT_TEXT_ALIGNMENT.value.multiplier;
+        int alignmentSpace = this.getBaseYSize() - (CHAT_PADDING * 2) - totalHeight;
+
+        int currentY = y + this.getBaseYSize() - CHAT_PADDING - (int) (alignmentSpace * (1 - yMult));
+        for (String message : visibleMessages) {
+            final int h = MathHelper.ceil(sr.heightOfConstrainedChars(message, wrapWidth));
+            currentY -= (h + LINE_SPACING);
+            drawAlignedLine(gui, sr, message, x, currentY, h, alpha, wrapWidth);
+        }
+
+        GLRenderer.disableState(State.BLEND);
+    }
+
+    private void drawAlignedLine(@NotNull Gui gui, @NotNull FontRenderer sr, CharSequence message, int x, int currentY, int h, int alpha, int wrapWidth) {
+        float xMult = GameSettings.HORIZONTAL_CHAT_TEXT_ALIGNMENT.value.multiplier;
+        int textWidth = Math.min(wrapWidth, (int) sr.stringWidthDouble(message));
+        int boxWidth = this.getBaseXSize() - (CHAT_PADDING * 2);
+        int renderX = x + CHAT_PADDING + (int) ((boxWidth - textWidth) * xMult);
+        int boxLeft = renderX - 1;
+        int boxRight = renderX + textWidth + 1;
+        gui.drawRect(boxLeft, currentY - 1, boxRight, currentY + h + 1, alpha / 2 << 24);
+        GLRenderer.enableState(State.BLEND);
+        sr.renderWidthConstrained(message, renderX, currentY, wrapWidth).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
+    }
+
+    private int computeTotalHeight(List<ChatLine> messages, int scroll, int linesUsed, boolean ignoreFadeout, int wrapWidth) {
+        int total = 0;
+        for (int i = 0; i < linesUsed; i++) {
+            int idx = scroll + i;
+            if (idx >= messages.size()) continue;
+            ChatLine line = messages.get(idx);
+            if (line.updateCounter >= 190 && !ignoreFadeout) continue;
+            total += MathHelper.ceil(mc.font.heightOfConstrainedChars(line.message, wrapWidth)) + LINE_SPACING;
+        }
+        return total;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java
new file mode 100644
index 000000000..d3f78bb73
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java
@@ -0,0 +1,74 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.chat.ScreenChat;
+import net.minecraft.client.option.OptionGuiScaleOverride;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import org.jetbrains.annotations.NotNull;
+
+public class HudComponentChatInput extends HudComponentMovable {
+    private HudComponentChat linkedChat;
+
+    public HudComponentChatInput(String key, int xSize, int ySize, Layout layout) {
+        super(key, xSize, ySize, layout);
+    }
+
+    public void linkChat(HudComponentChat chat) {
+        this.linkedChat = chat;
+    }
+
+    @Override
+    public int getBaseXSize() {
+        return this.linkedChat != null ? this.linkedChat.getBaseXSize() : super.getBaseXSize();
+    }
+
+    @Override
+    public OptionGuiScaleOverride getGuiScaleOverrideOption() {
+        return this.linkedChat != null ? this.linkedChat.getGuiScaleOverrideOption() : super.getGuiScaleOverrideOption();
+    }
+
+    @Override
+    public boolean isVisible() {
+        return mc.currentScreen instanceof ScreenChat;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return isVisible();
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        // Nothing rendered natively by the HUD loop, because ScreenChat handles its own rendering.
+        // However, ScreenChat will use these Layout bounds to draw the text entry field.
+    }
+
+    @Override
+    public void renderPreview(@NotNull Gui gui, @NotNull Layout layout, int xSizeScreen, int ySizeScreen) {
+
+        renderTranslucency();
+
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
+
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.pushFrame();
+        
+        int emotePickerButtonColor = 0x80ffffff;
+        int emotePickerTextColor = 0xffffffa0;
+        
+        gui.drawRect(x, y, x + 12, y + 12, emotePickerButtonColor);
+        gui.drawStringCenteredShadow(mc.font, Character.toString('☺'), x + 6, y + 2, emotePickerTextColor);
+
+        gui.drawRect(x + 14, y, x + getBaseXSize(), y + 12, 0x80000000);
+        gui.drawStringShadow(mc.font, "_", x + 16, y + 2, 0xE0E0E0);
+        
+        GLRenderer.popFrame();
+        GLRenderer.disableState(State.BLEND);
+    }
+}
